#include "demotcpclient.h"

#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <unistd.h>
#include <iostream>

DemoTCPClient::DemoTCPClient()
{
	sock = -1;
	port = 0;
	address = "";
}

bool DemoTCPClient::setup(string address , int port)
{
  	if(sock == -1)
	{
		sock = socket(AF_INET , SOCK_STREAM , 0);
		if (sock == -1)
		{
      			cout << "Could not create socket" << endl;
    		}
        }
  	if((signed)inet_addr(address.c_str()) == -1)
  	{
    		struct hostent *he;
    		struct in_addr **addr_list;
    		if ( (he = gethostbyname( address.c_str() ) ) == NULL)
    		{
		      herror("gethostbyname");
      		      cout<<"Failed to resolve hostname\n";
		      return false;
    		}
	   	addr_list = (struct in_addr **) he->h_addr_list;
    		for(int i = 0; addr_list[i] != NULL; i++)
    		{
    			server_addr.sin_addr = *addr_list[i];
		      break;
    		}
  	}
  	else
  	{
  		server_addr.sin_addr.s_addr = inet_addr( address.c_str() );
  	}
  	server_addr.sin_family = AF_INET;
  	server_addr.sin_port = htons( port );
  	if (connect(sock , (struct sockaddr *)&server_addr , sizeof(server_addr)) < 0)
  	{
    		perror("connect failed. Error");
    		return false;
  	}
  	return true;
}

bool DemoTCPClient::Send(unsigned char* data, int size)
{
	if(sock != -1)
	{
		if( send(sock , data , size , 0) < 0)
		{
			cout << "Send failed : " << data << endl;
			cout << "Send failed : " << size << endl;
			return false;
		}
	}
	else
		return false;
	return true;
}

int DemoTCPClient::receive(unsigned char* data, int size)
{
	memset(data, 0, size);

	int n;

	if( (n = recv(sock , data , size, 0)) < 0)
  	{
	    cout << "receive failed!" << endl;
		return -1;
  	}

	printf("receive data size = %d\n",n);

	for(int i = 0; i < n; i++)
	{
	    printf("%02x ",data[i]);
	}
	printf("\n");

	return n;
}

void DemoTCPClient::exit()
{
    close( sock );
}
